<?php

namespace Litecms\Coupan\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Litecms\Coupan\Interfaces\CoupanRepositoryInterface;

class CoupanPublicController extends BaseController
{
    // use CoupanWorkflow;

    /**
     * Constructor.
     *
     * @param type \Litecms\Coupan\Interfaces\CoupanRepositoryInterface $coupan
     *
     * @return type
     */
    public function __construct(CoupanRepositoryInterface $coupan)
    {
        $this->repository = $coupan;
        parent::__construct();
    }

    /**
     * Show coupan's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $coupans = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();


        return $this->response->title(trans('$coupan::$coupan.names'))
            ->view('$coupan::public.coupan.index')
            ->data(compact('$coupans'))
            ->output();
    }

    /**
     * Show coupan's list based on a type.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function list($type = null)
    {
        $coupans = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();


        return $this->response->title(trans('$coupan::$coupan.names'))
            ->view('$coupan::public.coupan.index')
            ->data(compact('$coupans'))
            ->output();
    }

    /**
     * Show coupan.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $coupan = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->response->title($$coupan->name . trans('$coupan::$coupan.name'))
            ->view('$coupan::public.coupan.show')
            ->data(compact('$coupan'))
            ->output();
    }

}
