<?php

namespace Litecms\Coupan\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class CoupanTransformer extends TransformerAbstract
{
    public function transform(\Litecms\Coupan\Models\Coupan $coupan)
    {
        return [
            'id'                => $coupan->getRouteKey(),
            'key'               => [
                'public'    => $coupan->getPublicKey(),
                'route'     => $coupan->getRouteKey(),
            ], 
            'offered_by'        => $coupan->offered_by,
            'coupan_type'       => $coupan->coupan_type,
            'coupan_code'       => $coupan->coupan_code,
            'description'       => $coupan->description,
            'amount'            => $coupan->amount,
            'status'            => $coupan->status,
            'product_ids'       => $coupan->product_ids,
            'url'               => [
                'public'    => trans_url('coupan/'.$coupan->getPublicKey()),
                'user'      => guard_url('coupan/coupan/'.$coupan->getRouteKey()),
            ], 
            'status'            => trans('app.'.$coupan->status),
            'created_at'        => format_date($coupan->created_at),
            'updated_at'        => format_date($coupan->updated_at),
        ];
    }
}